﻿Imports System.Collections.ObjectModel
Imports IdeaBlade.EntityModel
Imports IdeaBlade.Core
Imports System.Collections.Specialized
Imports System.Linq
Imports System.Collections.Generic

Namespace SimpleSteps

  Public Class MainPageViewModel

    Private _mgr As NorthwindIBEntities

    Public Property Employees() As ObservableCollection(Of Employee)
      Get
        Return m_Employees
      End Get
      Private Set(ByVal value As ObservableCollection(Of Employee))
        m_Employees = value
      End Set
    End Property
    Private m_Employees As ObservableCollection(Of Employee)

    Public Property Log() As ObservableCollection(Of String)
      Get
        Return m_Log
      End Get
      Private Set(ByVal value As ObservableCollection(Of String))
        m_Log = value
      End Set
    End Property
    Private m_Log As ObservableCollection(Of String)

    Public Sub New()
      AsyncMainPageViewModel()
    End Sub

    Async Sub AsyncMainPageViewModel()
      Employees = New ObservableCollection(Of Employee)()
      AddHandler Employees.CollectionChanged, AddressOf Employees_CollectionChanged
      Log = New ObservableCollection(Of String)()
      _mgr = New NorthwindIBEntities()

      AddHandler _mgr.Fetching, Sub(s, e) WriteToLog("Fetching " + e.Query.ElementType.Name)
      AddHandler _mgr.Queried, Sub(s, e) WriteToLog("Query returned " + e.Results.Cast(Of Object)().Count().ToString())

      Dim query = _mgr.Employees.Include("Orders")
      Dim results = Await query.ExecuteAsync()
      results.ForEach(Sub(emp) Employees.Add(emp))
    End Sub

    Public Sub Save()
      _mgr.SaveChangesAsync()
    End Sub

    Private Sub Employees_CollectionChanged(ByVal sender As Object, ByVal e As NotifyCollectionChangedEventArgs)
      Select Case e.Action
        Case NotifyCollectionChangedAction.Add
          Add(e.NewItems.Cast(Of Employee)())
          Exit Select
        Case NotifyCollectionChangedAction.Remove
          Delete(e.OldItems.Cast(Of Employee)())
          Exit Select
      End Select
    End Sub

    Private Sub Add(ByVal employees As IEnumerable(Of Employee))
      employees.ForEach(Sub(emp) _mgr.AddEntity(emp))
    End Sub

    Private Sub Delete(ByVal employees As IEnumerable(Of Employee))
      employees.ForEach(Sub(emp) emp.EntityAspect.Delete())
      Save()
    End Sub

    Private Sub WriteToLog(ByVal message As String)
      Log.Insert(0, message)
    End Sub


  End Class
End Namespace